/* $FreeBSD$ */

#include <pthread.h>
#include <stdio.h>
#include <signal.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <err.h>

#include "stress.h"

#define NTHREADS 256

volatile int done = 0;

int
setup(int nb)
{
	return (0);
}

void
cleanup(void)
{
}

void *
thr1(void *arg)
{
	return (0);
}

void *
thr2(void *arg)
{
	while (done == 0)
		pthread_yield();
	return (0);
}

int
test(void)
{
	pthread_t threads[NTHREADS];
	int i;
	int r;
	
	for (i = 0; i < NTHREADS; i++)
		if ((r = pthread_create(&threads[i], NULL, thr1, 0)) != 0)
			err(1, "pthread_create(): %s\n", strerror(r));

	for (i = 0; i < NTHREADS; i++)
		if (pthread_join(threads[i], NULL) != 0)
			err(1, "pthread_join(%d)", i);

	for (i = 0; i < NTHREADS; i++)
		if ((r = pthread_create(&threads[i], NULL, thr2, 0)) != 0)
			err(1, "pthread_create(): %s\n", strerror(r));
	done = 1;

	for (i = 0; i < NTHREADS; i++)
		if (pthread_join(threads[i], NULL) != 0)
			err(1, "pthread_join(%d)", i);

	return (0);
}
